/////////////////////////////////////////////////////////////////////////////////
// 2010.11.30 ver 0.14
// ςȂĂȂ肨DɂǂB
// -----------------------------------------------------------------------------
// cc65@wiki
// http://www34.atwiki.jp/cc65/
/////////////////////////////////////////////////////////////////////////////////
#define REGIST_PPU_CTRL1 (char*)0x2000
#define REGIST_PPU_CTRL2 (char*)0x2001
#define REGIST_PPU_STS   (char*)0x2002
#define REGIST_SPR_ADR   (char*)0x2003
#define REGIST_SPR_GRA   (char*)0x2004
#define REGIST_SCROLL    (char*)0x2005
#define REGIST_ADR       (char*)0x2006
#define REGIST_GRA       (char*)0x2007
#define REGIST_DMA       (char*)0x4014
#define JOYPAD           (char*)0x4016
#define BTN_A            0x80
#define BTN_B            0x40
#define BTN_SELECT       0x20
#define BTN_START        0x10
#define BTN_UP           0x08
#define BTN_DOWN         0x04
#define BTN_LEFT         0x02
#define BTN_RIGHT        0x01
#define GUN_TRIGGER      0x10
#define GUN_HIT          0x08
#define MIC_USE          0x04
 
unsigned char padinfo[2][2];
unsigned char padother;
 
//Rg[mF
void CheckPad()
{
    unsigned char i,j,ret;
    *JOYPAD = 1;
    *JOYPAD = 0;
    padother= 0;
    for(i=0; i < 2; i++) {
        padinfo[i][1] = padinfo[i][0];
        padinfo[i][0]= 0;
        for(j=0; j < 8; j++) {
            ret = *(JOYPAD + i);
            padinfo[i][0] <<= 1;
            padinfo[i][0] += (ret & 0x01);
            padother |= (ret & 0x0F);
        }
    }
}
 
//{^ςȂ@player:0=1P , 1=2P
char ButtonDown(unsigned char player,unsigned char btn)
{
    if(padinfo[player][0] & btn) {
        return 1;
    } else {
        return 0;
    }
}
 
//{^
char ButtonPush(unsigned char player,unsigned char btn)
{
    if((padinfo[player][0] & btn) && ! (padinfo[player][1] & btn)) {
        return 1;
    } else {
        return 0;
    }
}
 
//}CNEeȂ
char ControlOther(unsigned char btn)
{
    if(padother & btn) {
        return 1;
    } else {
        return 0;
    }
}
 
// PPURg[WX^̏
void InitPPU()
{
    *REGIST_PPU_CTRL1 = 0x00;
    *REGIST_PPU_CTRL2 = 0x00;
}
 
// PPURg[WX^̐ݒ
void SetPPU(unsigned char flag1,unsigned char flag2)
{
    *REGIST_PPU_CTRL1 = flag1;
    *REGIST_PPU_CTRL2 = flag2;
}
 
// XN[ݒ
void SetScroll(unsigned char x, unsigned char y)
{
    *REGIST_SCROLL = x;
    *REGIST_SCROLL = y;
}
 
//wiݒiJԂj
void FillBackground(unsigned char address1, unsigned char address2, unsigned char val, unsigned char cnt)
{
    char i;
 
    *REGIST_ADR = address1;
    *REGIST_ADR = address2;
    for (i = 0; i < cnt; i++)
    {
        *REGIST_GRA = val;
    }
}
 
//wiݒ
void SetBackground(unsigned char address1, unsigned char address2, unsigned char *bg, unsigned char cnt)
{
    char i;
 
    *REGIST_ADR = address1;
    *REGIST_ADR = address2;
    for (i = 0; i < cnt; i++)
    {
        *REGIST_GRA = *(bg + i);
    }
}
 
//WwĩAhXvZ
void GetBackgroundAddress(unsigned char screen, unsigned char x, unsigned char y, char *ret)
{
    unsigned int pos;
 
    switch (screen) {
    case 0:        //
        pos = 0x2000;
        break;
    case 1:        //E
        pos = 0x2800;
        break;
    case 2:        //
        pos = 0x2400;
        break;
    case 3:        //E
        pos = 0x2c00;
        break;
    }
 
    pos += y * 0x20 + x;
    *(ret + 0) = (pos & 0xff00) >> 8;
    *(ret + 1) =  pos & 0x00ff;
}
 
//ݒiJԂj
void FillAttribute(unsigned char address1, unsigned char address2, unsigned char val, unsigned char cnt)
{
    FillBackground(address1,address2,val,cnt);
}
 
//ݒ
void SetAttribute(unsigned char address1, unsigned char address2, unsigned char *atr, unsigned char cnt)
{
    SetBackground(address1,address2,atr,cnt);
}
 
//pbgݒ
void SetPalette(unsigned char *palette,unsigned char sprite)
{
    char i;
 
    *REGIST_ADR = 0x3f;
    if (sprite) {
        *REGIST_ADR = 0x10;
    } else {
        *REGIST_ADR = 0x00;
    }
 
    for (i = 0; i < 16; i++)
    {
        *REGIST_GRA = *(palette + i);
    }
}
 
//XvCgݒ
void SetSprite(unsigned char first,unsigned char x,unsigned char y,unsigned char index,unsigned char flag)
{
    if (first) {
        *REGIST_SPR_ADR=0x00;
    }
    *REGIST_SPR_GRA=y;
    *REGIST_SPR_GRA=index;
    *REGIST_SPR_GRA=flag;
    *REGIST_SPR_GRA=x;
}
 
//DMA]̈揉
void InitDMA(unsigned char *address)
{
    unsigned char i;
    for(i=0; i < 256; i++) {
        *(address + i)=0;
    }
}
 
//DMA]
void SetDMA(unsigned char *address,unsigned char first,unsigned char x,unsigned char y,unsigned char index,unsigned char flag)
{
    static unsigned char cnt;
    if (first) { cnt = 0; }
    *(address + cnt + 0)=y;
    *(address + cnt + 1)=index;
    *(address + cnt + 2)=flag;
    *(address + cnt + 3)=x;
    cnt+=4;
}
 
//DMA]
void SendDMA(unsigned char address)
{
    *REGIST_DMA = address;
}
 
//VBlank҂
void VBlank()
{
    while (! (*REGIST_PPU_STS & 0x80) );
}
 
//Oe҂
void ZeroSprite()
{
    while (  (*REGIST_PPU_STS & 0x40) );
    while (! (*REGIST_PPU_STS & 0x40) );
}
 

/******************************************************************************************************************************
kihon.h̉

    CheckPadFRg[̊mFB{IɖĂяoB
    ButtonDownFꂽ{^̊mFBij
    ButtonPushFꂽ{^̊mFBij
    ControlOtherF}CNEe̊mFB
    InitPPUFPPURg[WX^̏B
    SetPPUFPPURg[WX^̐ݒB
        flag1FPPURg[WX^P̐ݒB
            bit7FVBlankNMIs
            bit6FPPU}X^[/X[uZNg
            bit5FXvCgTCY(0:8x8,1:8x16)
            bit4FBGp^[e[uAhX(0:$0000,1:$1000)
            bit3FXvCgp^[e[uAhX(0:$0000,1:$1000)
            bit2FPPUAhXCNg(0:+1,1:+32)
            bit0,1F\l[e[uAhXԍi00F$2000EA01F$2400EA10F$2800EEA11F$2C00EEj
        flag2FPPURg[WX^Q̐ݒB
            bit5-7Fbit0=1̂ƂwiF/bit0=1̂ƂF
            000:ȂE001:΁E010:E100:(ȊO͕̐s)
            bit4FXvCg\(0:\,1:\)
            bit3FBG\(0:\,1:\)
            bit2FXvCgNbv(0:ʂ̍Whbg\Ȃ,1:NbvȂ)
            bit1FBGNbv(0:ʂ̍Whbg\Ȃ,1:NbvȂ)
            bit0FfBXvC^Cv(0:J[,1:mN)
    SetScrollFwĩXN[B
        xFʒuB
        yFcʒuB
    FillBackgroundFwi̐ݒiJԂjB
        address1Fo͊JnʒuiʂQoCgj
        address2Fo͊JnʒuiʂQoCgj
        valFo͓ei}X̔ԍj
        cntFo͂JԂ
    SetBackgroundFwi̐ݒB
        address1Fo͊JnʒuiʂQoCgj
        address2Fo͊JnʒuiʂQoCgj
        *bgFo͓ẽ|C^
        cntFo͓ẽoCg
    GetBackgroundAddressFWwĩAhXZoB
        screenF(0:E,1:E,2:,3:E)
        xFʒuB
        yFcʒuB
        *retFAhXi[PoCg~Q̔z
    SetPaletteFpbg̐ݒB
        *paletteFpbgẽ|C^
        spriteFOFwippbg@PFXvCgppbg
    FillAttributeFiwiS}X~S}Xɂǂ̃pbggj̐ݒBiJԂj
        address1Fo͐iʂQoCgj
        address2Fo͐iʂQoCgj
        valFo͓e
        cntFo͂JԂ
    SetAttributeFiwiS}X~S}Xɂǂ̃pbggj̐ݒB
        address1Fo͐iʂQoCgj
        address2Fo͐iʂQoCgj
        *atrFo͓ẽ|C^
        cntFo͓ẽoCg
    SetSpriteFXvCg̐ݒB
        firstF1=Pڂ̃XvCg 0=Qڈȍ~
        xFʒu
        yFcʒu
        indexFR}ڂ̉摜\邩
        flagF\@
            7bitF㉺]
            6bitFE]
            5bitFwiɕ\
            0,1bitFpbgԍ
    SetDMAFDMA]BiXvCgp̈̐ݒj
        *addressFXvCgp̈̊JnAhX
        firstF1=Pڂ̃XvCg 0=Qڈȍ~
        x,y,index,flagFSetSpriteƓeB
    SendDMAFDMA]
        addressFXvCgp̈̊JnAhX̎O 0x1=0x0100
    VBlankFVBlank҂B
    ZeroSpriteFOe҂B

SetRegisterESetBackgroundESetAttributeESetPalette͕֋X㕪Ă邾ŁAĂ鏈͓łB
FillBackgroundFillAttributelB

ӎ

    SetBackgroundɂ`悪ԂɍȂꍇAwi܂ɕ\܂B

@VBlank()
@SetBackground(0x20,0x00,(char *)bg,32);
@SetScroll( 0, 0 );
 

    ꎞIɔwi̕`~ÅԂɕ`悷邱Ƃŉł܂B

@SetPPU(0x08,0x06);
@SetBackground(0x20,0x00,(char *)bg,32);
@SetScroll( 0, 0 );
@SetPPU(0x08,0x1e);
 

    `悷͈͂߂邱Ƃłł܂B

@VBlank();
@SetBackground(0x20,0x00,(char *)bg,10)
@SetScroll( 0, 0 );
@VBlank();
@SetBackground(0x20,0x0a,(char *)bg,10)
@SetScroll( 0, 0 );
@VBlank();
@SetBackground(0x20,0x14,(char *)bg,12)
@SetScroll( 0, 0 );
 

    SetBackgroundĂяoɃx^ɏƂʓIłB
    i#define̎gp͖肠܂Bj

@*REGIST_ADR = 0x20;
@*REGIST_ADR = 0x00;
@*REGIST_GRA = 0;
@*REGIST_GRA = 1;
@     :
@     :
@*REGIST_GRA = 31;
******************************************************************************************************************************/
